jQuery(document).ready(async function($) {

    let subdomain = traveldesk_data.subdomain;
    let apiURL = traveldesk_data.api_url;
    let companyColor = '#250B6E';
    let aptReservations = {
        ArrivalDate: '',
        DepartureDate: '',
        DepartureTime: '',
        pickupDate: '',
        pickupTime: '',
        returnDate: '',
        returnTime: '',
        origin: '',
        destination: '',
        serviceType: 1,
        isActivityTransfer: true,
        isDestinationAirport: 0,
        isOriginAirport: 0,
        isArrival: true,
        isDeparture: false,
        arrivalAirline: '',
        arrivalFlightNumber: '',
        arrivalFlightDate: '',
        arrivalFlightTime: '',
        departureAirline: '',
        departureFlightNumber: '',
        departureFlightDate: '',
        departureFlightTime: '',
        adults: 2,
        kids: 0,
        infants: 0,
        vehicles: {
            vehiclePerCompany_id: 0,
            make: '',
            model: '',
            totalAmount: 0,
            Quantity: 0,
        },
        addons: [],
        client: {
            fname: '',
            lname: '',
            email: '',
            phone: '',
        },
        booking_id: '',
        client_id: '',
        status: 0,
        subtotal: 0,
        tax: 0,
        tax_amount: 0,
        total: 0,
        isPrepay: false,
        prepay_amount: 0,
        special_requests: '',
        promoCode: '',
        repCode: '',
        sendEmail: true,
        deviceInfo: {
            type: '',  // mobile, desktop, tablet
            orientation: '',  // portrait, landscape
            browserData: {},
        },
        utmParams: {},
        PDFlink: '',
        ally_booking_id: '',
        aptRes_type: null,
        // ... Cualquier otro campo necesario
    };    
    let companyData = null

    // Precargar los valores de aptReservations en los campos del formulario
    $('#adults').val(aptReservations.adults);
    $('#kids').val(aptReservations.kids);
    $('#infants').val(aptReservations.infants);

    $('#adults').on('change', function() {
        aptReservations.adults = parseInt($(this).val(), 10);
    });
    
    $('#kids').on('change', function() {
        aptReservations.kids = parseInt($(this).val(), 10);
    });
    
    $('#infants').on('change', function() {
        aptReservations.infants = parseInt($(this).val(), 10);
    });

    aptReservations.repCode = $('#repCode').val();

    // Mostrar el spinner cuando empieza a cargar los datos
    function showSpinner() {
        $('#loading-spinner').show();
    }

    // Ocultar el spinner cuando termina de cargar los datos
    function hideSpinner() {
        $('#loading-spinner').hide();
    }

    function updateDynamicFields() {
        // Mostrar el spinner y ocultar los campos dinámicos
        $('#loading-dynamic-fields').show();
        $('#dynamic-fields').hide();
        
        const isRoundTrip = aptReservations.serviceType === 2;
        const isAirport = aptReservations.isOriginAirport || aptReservations.isDestinationAirport;
        
        let fieldsHtml = '';
        
        if (isAirport) {
            if (isRoundTrip) {
                // Round Trip con Aeropuerto: Mostrar Arrival Date y Departure Date
                fieldsHtml += `
                    <div class="form-group">
                        <label for="arrivalDate">Arrival Date</label>
                        <div class="date-picker">
                            <input type="text" id="arrivalDate" class="form-control date-picker-input" placeholder="Select Arrival Date" readonly>
                            <div id="arrivalDatePicker" class="calendar" style="display: none;"></div>
                        </div>
                    </div>
                    <div class="form-group">
                        <label for="departureDate">Departure Date</label>
                        <div class="date-picker">
                            <input type="text" id="departureDate" class="form-control date-picker-input" placeholder="Select Departure Date" readonly>
                            <div id="departureDatePicker" class="calendar" style="display: none;"></div>
                        </div>
                    </div>
                    <hr width="100%" class="mt-4 mb-4"> <!-- Separación -->
                `;
            } else {
                // One Way con Aeropuerto
                if (aptReservations.isOriginAirport) {
                    // Si Origen es Aeropuerto: Mostrar Arrival Date
                    fieldsHtml += `
                        <div class="form-group">
                            <label for="arrivalDate">Arrival Date</label>
                            <div class="date-picker">
                                <input type="text" id="arrivalDate" class="form-control date-picker-input" placeholder="Select Arrival Date" readonly>
                                <div id="arrivalDatePicker" class="calendar" style="display: none;"></div>
                            </div>
                        </div>
                    `;
                } else if (aptReservations.isDestinationAirport) {
                    // Si Destino es Aeropuerto: Mostrar Departure Date
                    fieldsHtml += `
                        <div class="form-group">
                            <label for="departureDate">Departure Date</label>
                            <div class="date-picker">
                                <input type="text" id="departureDate" class="form-control date-picker-input" placeholder="Select Departure Date" readonly>
                                <div id="departureDatePicker" class="calendar" style="display: none;"></div>
                            </div>
                        </div>
                    `;
                }
                fieldsHtml += `<hr width="100%" class="mt-4 mb-4">`; // Separación
            }
        } else {
            // No es Transporte de Aeropuerto
            if (isRoundTrip) {
                // Round Trip: Mostrar Pickup Date, Pickup Time, Return Date y Return Time
                fieldsHtml += `
                    <div class="form-group">
                        <label for="pickupDate">Pickup Date</label>
                        <div class="date-picker">
                            <input type="text" id="pickupDate" class="form-control date-picker-input" placeholder="Select Pickup Date" readonly>
                            <div id="pickupDatePicker" class="calendar" style="display: none;"></div>
                        </div>
                    </div>
                    <div class="form-group">
                        <label for="pickupTime">Pickup Time</label>
                        <div class="time-picker">
                            <input type="text" id="pickupTime" class="form-control time-picker-input" placeholder="Select Pickup Time" readonly>
                            <div id="pickupTimePicker" class="time-selector" style="display: none;"></div>
                        </div>
                    </div>
                    <div class="form-group">
                        <label for="returnDate">Return Date</label>
                        <div class="date-picker">
                            <input type="text" id="returnDate" class="form-control date-picker-input" placeholder="Select Return Date" readonly>
                            <div id="returnDatePicker" class="calendar" style="display: none;"></div>
                        </div>
                    </div>
                    <div class="form-group">
                        <label for="returnTime">Return Time</label>
                        <input type="text" id="returnTime" class="form-control time-picker-input" placeholder="Select Return Time" readonly>
                        <div id="returnTimePicker" class="time-selector" style="display: none;"></div>
                    </div>
                    <hr width="100%" class="mt-4 mb-4"> <!-- Separación -->
                `;
            } else {
                // One Way: Mostrar Pickup Date y Pickup Time
                fieldsHtml += `
                    <div class="form-group">
                        <label for="pickupDate">Pickup Date</label>
                        <div class="date-picker">
                            <input type="text" id="pickupDate" class="form-control date-picker-input" placeholder="Select Pickup Date" readonly>
                            <div id="pickupDatePicker" class="calendar" style="display: none;"></div>
                        </div>
                    </div>
                    <div class="form-group">
                        <label for="pickupTime">Pickup Time</label>
                        <div class="time-picker">
                            <input type="text" id="pickupTime" class="form-control time-picker-input" placeholder="Select Pickup Time" readonly>
                            <div id="pickupTimePicker" class="time-selector" style="display: none;"></div>
                        </div>
                    </div>
                    <hr width="100%" class="mt-4 mb-4"> <!-- Separación -->
                `;
            }
        }
    
        // Actualizar el contenido de los campos dinámicos
        $('#dynamic-fields').html(fieldsHtml);
        
        // Una vez que los campos están actualizados, ocultar el spinner y mostrar los campos
        $('#loading-dynamic-fields').hide();
        $('#dynamic-fields').show();
    
        // Inicializar los DatePickers y TimePickers aquí
        initializeDatePickers();
        initializeTimePickers();
    
        // Inicializar tooltips si es necesario
        setupTooltip();
    }       

    window.swapValues = async function() {
        // Intercambiar valores en aptReservations
        [aptReservations.origin, aptReservations.destination] = [aptReservations.destination, aptReservations.origin];
        [aptReservations.fullOriginAddress, aptReservations.fullDestinationAddress] = [aptReservations.fullDestinationAddress, aptReservations.fullOriginAddress];
        [aptReservations.originLatitude, aptReservations.destinationLatitude] = [aptReservations.destinationLatitude, aptReservations.originLatitude];
        [aptReservations.originLongitude, aptReservations.destinationLongitude] = [aptReservations.destinationLongitude, aptReservations.originLongitude];
        
        // Actualizar los campos de entrada SIN disparar 'change'
        $('#origin').val(aptReservations.origin);
        $('#destination').val(aptReservations.destination);
        
        // Re-ejecutar las verificaciones para origen y destino
        await isOriginAirport(); // Verificar si el nuevo origen es un aeropuerto
        await isDestinationAirport(); // Verificar si el nuevo destino es un aeropuerto
        
        // Actualizar los campos dinámicos si es necesario
        updateDynamicFields();
    };

    // Ejemplo de uso: cuando se selecciona un destino, llamamos a la función
    window.selectDestination = async function(destinationId) {

        if(destinationId){
            aptReservations.destinationID = destinationId;
        }
        console.log("Selected Destination ID:", destinationId);

        // Obtener información del destino después de seleccionar
        await getDestinationInfo();

        // Cambiar el paso al siguiente
        activateTab('calendar'); // Cambia al calendario una vez seleccionado el destino
    };

    // Función para manejar el estado de las pestañas
    function activateTab(tabId) {
        console.log('activateTab called with tabId:', tabId);
        // Remover 'active' de todos los botones de pestañas
        $('.nav-link').removeClass('active');
        // Remover 'active show' de todos los contenidos de pestañas
        $('.tab-pane').removeClass('active show');
        // Habilitar la pestaña seleccionada (remover 'disabled' del botón)
        $(`#${tabId}-tab`).removeClass('disabled');
        // Activar el botón de la pestaña seleccionada
        $(`#${tabId}-tab`).addClass('active');
        // Mostrar el contenido de la pestaña seleccionada
        $(`#${tabId}`).addClass('active show');

        // Si la pestaña es "vehicles", cargar los vehículos
        if (tabId === 'vehicles') {
            console.log('tabId matches "vehicles", calling getFleet()');
            getFleet();
        } else if (tabId.trim().toLowerCase() === 'addons') {
            console.log('tabId matches "addons", calling getAddons()');
            getAddons();
        } else if (tabId === 'client') {
            console.log('tabId matches "client", initializing client tab');
            initializeClientTab();
            
        }
    }
          
    // Función para aplicar el color principal de la empresa
    function applyCompanyColor(color) {
        companyColor = color || '#250B6E';
        document.documentElement.style.setProperty('--company-color', companyColor);
    
        // Aplicar el color de fondo y borde con !important a los botones principales
        $('.btn-primary').each(function() {
            this.style.setProperty('background-color', companyColor, 'important');
            this.style.setProperty('border-color', companyColor, 'important');
        });
    
        // Aplicar a los botones de outline (para los radios de tipo de servicio)
        $('.btn-outline-primary').each(function() {
            this.style.setProperty('border-color', companyColor, 'important');
        });
    
        // Aplicar color en el botón de Select Destination
        $('.btn-select-destination').each(function() {
            this.style.setProperty('background-color', companyColor, 'important');
            this.style.setProperty('border-color', companyColor, 'important');
        });

        // Aplicar el color al botón de intercambio de valores (swap button)
        $('.switcher-button').each(function() {
            this.style.setProperty('border-color', companyColor, 'important');
            this.style.setProperty('color', companyColor, 'important');  // Cambiar el color del texto o ícono
        });

        // Estilo para el hover del botón de intercambio de valores, incluyendo el ícono
        const style = document.createElement('style');
        style.innerHTML = `
            .switcher-button:hover {
                background-color: ${companyColor} !important;
                color: #fff !important;  /* Cambia el color del texto o ícono a blanco cuando se hace hover */
            }
            .switcher-button:hover i {
                color: #fff !important;  /* Cambia el color del ícono a blanco cuando se hace hover */
            }
            .switcher-button:active {
                background-color: ${companyColor} !important;
                color: #fff !important;  /* Cambia el color del texto o ícono a blanco cuando se hace clic */
            }
            .switcher-button:active i {
                color: #fff !important;  /* Cambia el color del ícono a blanco cuando se hace clic */
            }
        `;
        document.head.appendChild(style);
    }    

    // Función para obtener los datos de la empresa desde la API
    async function fetchCompanyData(subdomain) {
        showSpinner();
        try {
            const response = await fetch(`${apiURL}public/search-company/${subdomain}`);
            if (response.ok) {
                const data = await response.json();
                console.log('Company data: ', data);
                applyCompanyColor(data.data.company_color);
                aptReservations.company_id = data.data.company_id;
                companyData = data.data; // Almacena los datos de la compañía
                
                return data;
            } else {
                throw new Error('Company not found');
            }
        } catch (error) {
            console.error('Error fetching company data:', error);
            return null;
        } finally {
            hideSpinner();
        }
    }

    // Función para obtener todas las ciudades
    async function getCities() {
        showSpinner();
        try {
            const API_URL = `${apiURL}public/transportation_destinations`;
            const headers = {
                'Accept': 'application/json',
                'Content-Type': 'application/json'
            };
            const res = await fetch(API_URL, {
                method: 'GET',
                headers: headers
            });
            const response = await res.json();
            if ('errors' in response) {
                throw new Error('Error fetching cities');
            }
            return response;
        } catch (error) {
            console.error('Error fetching cities:', error);
            return null;
        } finally {
            hideSpinner();
        }
    }

    // Función para obtener las ciudades filtradas según los destinos seleccionados
    async function getFilteredCities() {
        showSpinner();
        try {
            const companyData = await fetchCompanyData(subdomain)

            // Now that company data is fetched and aptReservations.company_id is set, find auto coupon
            await findAutoCoupon();

            if (!companyData) throw new Error("Company data not found");
    
            const allCitiesResponse = await getCities();
            if (!allCitiesResponse || !allCitiesResponse.data) throw new Error("Cities data not found");
    
            const allCities = allCitiesResponse.data;
            const selectedDestinations = companyData.data.company_selectedDestinations.split(',');
    
            const filteredCities = allCities.filter(city => selectedDestinations.includes(city.TranspDest_city));
    
            const citiesArray = filteredCities.sort((a, b) => a.TranspDest_city.localeCompare(b.TranspDest_city))
                .map(city => ({
                    id: city.TranspDest_id,
                    name: city.TranspDest_city,
                    image: city.TranspDest_image
                }));
    
            console.log("Filtered Cities Array:", citiesArray); // <-- Aquí agregamos el log
    
            return citiesArray;
        } catch (error) {
            console.error('Error filtering cities:', error);
            return [];
        } finally {
            hideSpinner();
        }
    }
    
    // Nueva función: obtener información del destino
    async function getDestinationInfo() {
        try {
            const destinationID = aptReservations.destinationID;
            console.log('DestinationID_JSON: ', destinationID);

            // Llamada a la API para obtener información del destino
            const response = await fetch(`${apiURL}public/transportation_destinations/${destinationID}`, {
                method: 'GET',
                headers: {
                    'Accept': 'application/json',
                    'Content-Type': 'application/json',
                },
            });

            if (!response.ok) {
                throw new Error('Error fetching destination info');
            }

            const data = await response.json();
            console.log('Full Destination Data: ', data);

            // Verificar si TranspDest_geofence está definido y es un string válido
            if (data && data.data.TranspDest_geofence) {
                const geofenceData = JSON.parse(data.data.TranspDest_geofence);  // Parsear la cadena JSON
                console.log('Parsed Geofence Data: ', geofenceData);



                // Almacenar los datos en aptReservations
                aptReservations.destinationItem = geofenceData;
                aptReservations.originalDestinationData = JSON.parse(JSON.stringify(data.data));

                // Iniciar Google Places Autocomplete después de recibir la información
                initGooglePlacesAutocomplete();
            } else {
                throw new Error('Geofence data not available or not in correct format');
            }

        } catch (error) {
            console.error('Error during the process:', error);
        }
    }

    function loadGeofences() {
        if (aptReservations.zones && aptReservations.zones.length > 0) {
            aptReservations.geofences = aptReservations.zones.map(item => ({
                id: item.zonePerCompany_id,
                name: item.zone.zone_name,
                isAirport: item.zone.isAirport,
                geofence: JSON.parse(item.zone.zone_geofence)
            }));
            console.log('Loaded Geofences:', aptReservations.geofences);
        } else {
            console.error('No zones available to load geofences');
        }
    }    
    
    async function checkGeofence(location) {
        const point = {
            lat: location === 'origin' ? aptReservations.originLatitude : aptReservations.destinationLatitude,
            lng: location === 'origin' ? aptReservations.originLongitude : aptReservations.destinationLongitude,
        };
    
        const foundGeofence = aptReservations.geofences.find(geofence =>
            pointInPolygon(point, geofence.geofence)
        );
    
        let isAirport = false;
        let selectedGeofence = null;
    
        if (foundGeofence) {
            aptReservations.geofenceId = foundGeofence.id;
            selectedGeofence = foundGeofence.id;
            isAirport = foundGeofence.isAirport;
            aptReservations.GeoFenceError = 0;
        } else {
            aptReservations.GeoFenceError = 1;
            console.error("Location is not within any of our zones.");
        }
    
        return { isAirport, selectedGeofence };
    }
    
    function pointInPolygon(point, polygon) {
        let isInside = false;
        const x = point.lat, y = point.lng;
    
        for (let i = 0, j = polygon.length - 1; i < polygon.length; j = i++) {
            const xi = polygon[i].lat, yi = polygon[i].lng;
            const xj = polygon[j].lat, yj = polygon[j].lng;
    
            const intersect = ((yi > y) != (yj > y)) && (x < (xj - xi) * (y - yi) / (yj - yi) + xi);
            if (intersect) isInside = !isInside;
        }
    
        return isInside;
    }
    
    async function getZones() {
        try {
            const userCompany = aptReservations.company_id;
            console.log('userCompany: ', userCompany);
    
            const API_URL = `${apiURL}public/search-company-zones`;
    
            const headers = {
                'Accept': 'application/json',
                'Content-Type': 'application/json',
                'User-Company': userCompany
            };
    
            // Realizar la solicitud a la API para obtener las zonas
            const response = await fetch(API_URL, {
                method: 'GET',
                headers: headers
            });
    
            // Manejo de la respuesta
            if (!response.ok) {
                throw new Error('Error fetching zones');
            }
    
            const data = await response.json();
            console.log('Zones Data:', data);
    
            // Filtrar y almacenar las zonas activas en aptReservations
            if (data.data && Array.isArray(data.data)) {
                aptReservations.zones = data.data.filter(item => item.zonePerCompany_status === 1);
                console.log('Filtered Zones:', aptReservations.zones);
                
                // Cargar geofences a partir de las zonas
                loadGeofences();
            } else {
                throw new Error('Invalid data format');
            }
    
        } catch (error) {
            console.error('Error during getZones:', error);
        }
    }       

    function SET_IS_ARRIVAL() {
        aptReservations.isArrival = true;
        aptReservations.isDeparture = false;
    }
    
    function SET_IS_DEPARTURE() {
        aptReservations.isArrival = false;
        aptReservations.isDeparture = true;
        aptReservations.DepartureTime = '12:00';
    }
    
    function SET_IS_ROUNDTRIP() {
        aptReservations.isArrival = true;
        aptReservations.isDeparture = true;
    }

    async function isOriginAirport() {
        console.log('isOriginAirport started: ');
        
        await getZones();
        const { isAirport, selectedGeofence } = await checkGeofence('origin');
        aptReservations.isOriginAirport = !!isAirport; // Convertir a booleano
        aptReservations.originZone = selectedGeofence;
    
        if (aptReservations.serviceType === 2) {
            SET_IS_ROUNDTRIP();
        } else {
            if (aptReservations.isOriginAirport) {
                SET_IS_DEPARTURE();
            } else {
                SET_IS_ARRIVAL();
            }
        }
        updateDynamicFields(); // Actualizar campos dinámicos después de verificar si es aeropuerto
    }
    
    async function isDestinationAirport() {
        await getZones();
        const { isAirport, selectedGeofence } = await checkGeofence('destination');
        aptReservations.isDestinationAirport = !!isAirport; // Convertir a booleano
        aptReservations.destinationZone = selectedGeofence;
    
        if (aptReservations.serviceType === 2) {
            SET_IS_ROUNDTRIP();
        } else {
            if (aptReservations.isDestinationAirport) {
                SET_IS_DEPARTURE();
            } else {
                SET_IS_ARRIVAL();
            }
        }
        updateDynamicFields(); // Actualizar campos dinámicos después de verificar si es aeropuerto
    }    

    // Función para inicializar Google Places Autocomplete
    function initGooglePlacesAutocomplete(bounds) {
        const google = window.google;
    
        if (!google) {
            console.error("Google Maps API no está disponible.");
            return;
        }
    
        // Si no se pasan bounds, calcularlos a partir de destinationItem
        if (!bounds && aptReservations.destinationItem && aptReservations.destinationItem.length > 0) {
            bounds = new google.maps.LatLngBounds();
            aptReservations.destinationItem.forEach(coord => {
                bounds.extend(new google.maps.LatLng(coord.lat, coord.lng));
            });
        }
    
        if (!bounds) {
            console.error("No se pueden definir los bounds para Google Places Autocomplete.");
            return;
        }
    
        // Función para construir una dirección simplificada
        function buildSimplifiedAddress(place) {
            let simplifiedAddress = '';
            const addressComponents = place.address_components;
            if (addressComponents) {
                const locality = addressComponents.find(component => component.types.includes("locality"));
                const administrativeArea = addressComponents.find(component => component.types.includes("administrative_area_level_1"));
                const country = addressComponents.find(component => component.types.includes("country"));
    
                if (place.name !== locality.long_name) {
                    simplifiedAddress = place.name + ', ';
                }
    
                simplifiedAddress += locality ? `${locality.long_name}` : "";
                simplifiedAddress += administrativeArea ? `, ${administrativeArea.long_name}` : "";
                simplifiedAddress += country ? `, ${country.long_name}` : "";
            }
    
            return simplifiedAddress;
        }
    
        // Autocomplete para el campo 'origin'
        const autocompleteOrigin = new google.maps.places.Autocomplete(
            document.getElementById('origin'),
            {
                bounds: bounds,
                strictBounds: true
            }
        );
    
        autocompleteOrigin.addListener("place_changed", async () => {
            const place = autocompleteOrigin.getPlace();
            if (place.geometry) {
                aptReservations.fullOriginAddress = buildSimplifiedAddress(place);
                aptReservations.originLatitude = place.geometry.location.lat();
                aptReservations.originLongitude = place.geometry.location.lng();
                aptReservations.origin = buildSimplifiedAddress(place);
    
                // Verificar la geofence para la ubicación de origen
                await isOriginAirport(); // Llama a la función para verificar geofence
            }
        });
    
        // Autocomplete para el campo 'destination'
        const autocompleteDestination = new google.maps.places.Autocomplete(
            document.getElementById('destination'),
            {
                bounds: bounds,
                strictBounds: true
            }
        );
    
        autocompleteDestination.addListener("place_changed", async () => {
            const place = autocompleteDestination.getPlace();
            if (place.geometry) {
                aptReservations.fullDestinationAddress = buildSimplifiedAddress(place);
                aptReservations.destinationLatitude = place.geometry.location.lat();
                aptReservations.destinationLongitude = place.geometry.location.lng();
                aptReservations.destination = buildSimplifiedAddress(place);
    
                // Verificar la geofence para la ubicación de destino
                await isDestinationAirport(); // Llama a la función para verificar geofence
            }
        });
    }
      

    // Renderizar las ciudades y gestionar las pestañas
    const citiesArray = await getFilteredCities();
    if (citiesArray.length > 1) {
        // Mostrar la pestaña de destinos si hay más de una ciudad
        $('#tab-destinations').show();
        activateTab('destinations');
        $('#calendar-tab .step-number').text('2');
        $('#vehicles-tab .step-number').text('3');
        $('#addons-tab .step-number').text('4');
        $('#client-tab .step-number').text('5');
    } else {
        // Si solo hay una ciudad o ninguna
        $('#tab-destinations').hide();
        activateTab('calendar'); // Mostrar calendario si solo hay una ciudad
        $('#calendar-tab .step-number').text('1');
        $('#vehicles-tab .step-number').text('2');
        $('#addons-tab .step-number').text('3');
        $('#client-tab .step-number').text('4');
    
        // Caso especial para una sola ciudad
        if (citiesArray.length === 1) {
            aptReservations.destinationID = citiesArray[0].id;  // Asignar el ID de la ciudad
    
            console.log("Selected Destination ID (auto):", aptReservations.destinationID);
    
            await selectDestination(citiesArray[0].id);  // Llamar la función para manejar la selección de destino
        }
    }
    
    // Manejo del contenido de las ciudades (si hay más de una)
    if (citiesArray.length > 1) {
        const bounds = new google.maps.LatLngBounds();  // Definir límites para Google Maps Autocomplete
        citiesArray.forEach(function(city) {
            const cardHTML = `
                <div class="col-md-4 mb-4">
                    <div class="card">
                        ${city.image ? `<img src="${city.image}" class="card-img-top" alt="City Image">` : ''}
                        <div class="card-body">
                            <h5 class="card-title">${city.name}</h5>
                            <button class="btn btn-primary btn-sm btn-select-destination" style="background-color: var(--company-color) !important; border-color: var(--company-color) !important;" onclick="selectDestination(${city.id})">Select Destination</button>
                        </div>
                    </div>
                </div>`;
            $('#destinations-container').append(cardHTML);
            bounds.extend(new google.maps.LatLng(city.latitude, city.longitude));
        });
    
        initGooglePlacesAutocomplete(bounds);
    } else if (citiesArray.length === 0) {
        $('#destinations-container').html('<p>No destinations found.</p>');
    }

    async function fetchRepresentativeInfo(userCompany, repID) {
        try {
            const API_URL = `${apiURL}public/find-sales-representative/${repID}`;
            const response = await fetch(API_URL, {
                method: 'GET',
                headers: {
                    'Accept': 'application/json',
                    'Content-Type': 'application/json',
                    'User-Company': userCompany
                }
            });
            const data = await response.json();
            console.log('Response from server:', data);
            if ('errors' in data) {
                return { success: false, errors: data.errors };
            }
            return { success: true, data: data };
        } catch (error) {
            console.error('Error fetching representative info:', error);
            return { success: false, errors: [error.message] };
        }
    }
    
    async function findAutoCoupon() {
        try {
            const companyId = aptReservations.company_id;
            console.log('Attempting to find auto coupon for companyId:', companyId);
    
            const API_URL = `${apiURL}public/find-coupon-auto/${companyId}`;
    
            const response = await fetch(API_URL, {
                method: 'GET',
                headers: {
                    'Accept': 'application/json',
                    'Content-Type': 'application/json'
                },
            });
    
            const data = await response.json();
    
            if (data.message === 'Coupon found') {
                aptReservations.promoCode = data.data.coupon_code;
                aptReservations.PRE_coupon_type = data.data.coupon_type;
                aptReservations.PRE_coupon_amount = data.data.coupon_amount;
    
                if (data.data.coupon_apply_on === 1) {
                    aptReservations.couponAlreadyApplied = 1;
                }
                console.log('Auto coupon applied:', data.data.coupon_code);
            } else {
                console.log('No auto coupon found.');
            }
    
        } catch (error) {
            console.error('Error during findAutoCoupon:', error);
        }
    }    

    function displayErrors(errors) {
        $('#form-errors').html(errors.join('<br>')).show();
    }

    // Manejador de envío del formulario
    $('#calendar-form').on('submit', async function(e) {
        e.preventDefault();
        let errors = [];
        let isSending = true;

        // Mostrar el spinner en el botón "Next"
        $('#next-spinner').show();
        $('#next-icon').hide();
        $('button[type="submit"]').prop('disabled', true);

        // Verificar GeoFenceError
        if (aptReservations.GeoFenceError === 1) {
            errors.push('Location is not within any of our zones.');
            isSending = false;
        }

        // Actualizar aptReservations con los valores del formulario
        aptReservations.serviceType = parseInt($('input[name="serviceType"]:checked').val());
        aptReservations.origin = $('#origin').val();
        aptReservations.destination = $('#destination').val();
        aptReservations.pickupDate = $('#pickupDate').val();
        aptReservations.pickupTime = $('#pickupTime').val();
        aptReservations.adults = $('#adults').val();
        aptReservations.kids = $('#kids').val();
        aptReservations.infants = $('#infants').val();
        aptReservations.repCode = $('#repCode').val(); // Obtener el valor de repCode

        if (aptReservations.serviceType === 2) {
            aptReservations.returnDate = $('#returnDate').val();
            aptReservations.returnTime = $('#returnTime').val();
        }

        const repID = aptReservations.repCode;
        const userCompany = aptReservations.company_id;

        // Validar y obtener información del representante
        if (repID) {
            try {
                const response = await fetchRepresentativeInfo(userCompany, repID);
                if (response.success) {
                    console.log('Rep Found!');
                    // Puedes almacenar la información del representante si es necesario
                    aptReservations.representativeInfo = response.data;
                } else {
                    errors.push('Sales representative not found');
                    isSending = false;
                }
            } catch (error) {
                errors.push('Failed to fetch representative info.');
                isSending = false;
            }
        }

        // Verificar si solo se permite transporte de aeropuerto
        if (companyData.booking_options && companyData.booking_options[0].onlyAirport === 1) {
            if (aptReservations.isOriginAirport !== 1 && aptReservations.isDestinationAirport !== 1) {
                errors.push('The company only allows airport transportation services. Please select the airport on either Origin or Destination.');
                isSending = false;
            }
        }

        let formattedArrivalDate = aptReservations.ArrivalDate;
        let formattedDepartureDate = aptReservations.DepartureDate;

        let XformattedArrivalDate = new Date(aptReservations.ArrivalDate);
        let XformattedDepartureDate = new Date(aptReservations.DepartureDate);
        let XformattedPickupDate = new Date(aptReservations.pickupDate);
        let XformattedReturnDate = new Date(aptReservations.returnDate);

        // Validación de fechas para Round Trip
        if (parseInt(aptReservations.serviceType) === 2) {
            if (XformattedArrivalDate > XformattedDepartureDate) {
                errors.push('The arrival date cannot be later than the departure date.');
                isSending = false;
            }
            if (XformattedPickupDate > XformattedReturnDate) {
                errors.push('The pickup date cannot be later than the return date.');
                isSending = false;
            }
        }

        let submissionData = {
            serviceType: aptReservations.serviceType,
            origin: aptReservations.fullOriginAddress || aptReservations.origin,
            destination: aptReservations.fullDestinationAddress || aptReservations.destination,
            adults: aptReservations.adults,
            kids: aptReservations.kids,
            infants: aptReservations.infants,
        };

        let Booking_Anticipation = 0;

        if (companyData.booking_options && companyData.booking_options[0].bookingOptions_anticipation_status === 1) {
            Booking_Anticipation = companyData.booking_options[0].bookingOptions_anticipation;

            aptReservations.BO_status = companyData.booking_options[0].bookingOptions_anticipation_status;
            aptReservations.BO_hours = companyData.booking_options[0].bookingOptions_anticipation;
        }

        let today = new Date();

        // Agregar datos de fechas según el tipo de viaje
        if (parseInt(aptReservations.serviceType) === 1 && (aptReservations.isOriginAirport || aptReservations.isDestinationAirport)) {
            let timeDiffHours;

            if (aptReservations.isOriginAirport) {
                // Caso ARRIVAL
                let arrivalDate = new Date(XformattedArrivalDate);
                timeDiffHours = (arrivalDate - today) / (1000 * 3600);

                if (timeDiffHours < Booking_Anticipation) {
                    if (timeDiffHours <= 0 && companyData.booking_options[0].bookingOptions_anticipation_status === 0) {
                        errors.push(`No bookings can be accepted for today.`);
                        isSending = false;
                    } else {
                        errors.push(`Please select an arrival date at least ${Booking_Anticipation} hours from now.`);
                        isSending = false;
                    }
                }

                submissionData.ArrivalDate = formattedArrivalDate;

            } else {
                // Caso DEPARTURE
                let departureDate = new Date(formattedDepartureDate);
                timeDiffHours = (departureDate - today) / (1000 * 3600);

                if (timeDiffHours < Booking_Anticipation) {
                    errors.push(`Please select a departure date at least ${Booking_Anticipation} hours from now.`);
                    isSending = false;
                }

                submissionData.DepartureDate = formattedDepartureDate;
                submissionData.DepartureTime = aptReservations.DepartureTime;
            }
        } else if (parseInt(aptReservations.serviceType) === 2 && (aptReservations.isOriginAirport || aptReservations.isDestinationAirport)) {
            // Caso ROUND TRIP

            let arrivalDate = new Date(XformattedArrivalDate);
            let departureDate = new Date(XformattedDepartureDate);
            let arrivalDiffHours = (arrivalDate - today) / (1000 * 3600);
            let departureDiffHours = (departureDate - today) / (1000 * 3600);

            if (arrivalDiffHours < Booking_Anticipation || departureDiffHours < Booking_Anticipation) {
                errors.push(`Please select arrival and departure dates at least ${Booking_Anticipation} hours from now.`);
                isSending = false;
            }

            submissionData.ArrivalDate = formattedArrivalDate;
            submissionData.DepartureDate = formattedDepartureDate;
            submissionData.DepartureTime = aptReservations.DepartureTime;
        }

        if (errors.length === 0) {
            isSending = false;

            // Actualizar aptReservations con submissionData
            Object.assign(aptReservations, submissionData);

            // Cambiar al siguiente paso
            activateTab('vehicles');

            // Ocultar el spinner y habilitar el botón
            $('#next-spinner').hide();
            $('#next-icon').show();
            $('button[type="submit"]').prop('disabled', false);
        } else {
            isSending = false;
            // Mostrar errores en la interfaz
            displayErrors(errors);

            // Ocultar el spinner y habilitar el botón
            $('#next-spinner').hide();
            $('#next-icon').show();
            $('button[type="submit"]').prop('disabled', false);
        }
    });

    // Mostrar u ocultar campos de return (Round trip)
    $('input[name="serviceType"]').on('change', function () {
        aptReservations.serviceType = parseInt($('input[name="serviceType"]:checked').val());
        updateDynamicFields(); // Actualizar campos dinámicos
    });

    // Simulación de detección de si es aeropuerto (lógica basada en tu backend)
    function detectAirport(location) {
        // Aquí puedes usar tus funciones de API para detectar si es aeropuerto
        if (location === 'origin') {
            aptReservations.isOriginAirport = true; // Simulación
        } else if (location === 'destination') {
            aptReservations.isDestinationAirport = true; // Simulación
        }
    }

    /* ||||||||||||||||||||||||||||||||||| FUNCIONES DATEPICKER ||||||||||||||||||||||||||||||||||||||| */

    function initializeDatePickers() {
        const datePickerConfigs = [
            {
                inputId: 'arrivalDate',
                pickerId: 'arrivalDatePicker',
                reservationKey: 'ArrivalDate'
            },
            {
                inputId: 'departureDate',
                pickerId: 'departureDatePicker',
                reservationKey: 'DepartureDate'
            },
            {
                inputId: 'pickupDate',
                pickerId: 'pickupDatePicker',
                reservationKey: 'pickupDate'
            },
            {
                inputId: 'returnDate',
                pickerId: 'returnDatePicker',
                reservationKey: 'returnDate'
            },
            {
                inputId: 'departure-flight-date',
                pickerId: 'departureFlightDatePicker',
                reservationKey: 'departureFlightDate'
            },
            {
                inputId: 'arrival-flight-date',
                pickerId: 'arrivalFlightDatePicker',
                reservationKey: 'arrivalFlightDate'
            },
        ];

        datePickerConfigs.forEach(config => {
            if (document.getElementById(config.inputId)) {
                new DatePicker(config.inputId, config.pickerId, function(selectedDate) {
                    // **Cambio 1.1:** Formatear a 'YYYY/MM/DD'
                    const formattedDate = formatDateToYYYYMMDD(selectedDate);
                    aptReservations[config.reservationKey] = formattedDate;
                });
            }
        });
    }

    // Nueva función para formatear fechas a 'YYYY/MM/DD'
    function formatDateToYYYYMMDD(dateStr) {
        const date = new Date(dateStr);
        const year = date.getFullYear();
        const month = (`0${date.getMonth() + 1}`).slice(-2);
        const day = (`0${date.getDate()}`).slice(-2);
        return `${year}-${month}-${day}`;
    }

    // Inicializar Flatpickr con el nuevo formato de fecha
    $('#arrivalDate').flatpickr({
        minDate: 'today',
        dateFormat: 'Y/m/d', // **Cambio 1.1:** Formato de fecha 'YYYY/MM/DD'
        onChange: function(selectedDates, dateStr, instance) {
            // Actualizar tu objeto aptReservations
            aptReservations.ArrivalDate = dateStr;
        }
    });

    $('#departureDate').flatpickr({
        minDate: 'today',
        dateFormat: 'Y/m/d', // Formato 'YYYY/MM/DD'
        onChange: function(selectedDates, dateStr, instance) {
            aptReservations.DepartureDate = dateStr;
        }
    });
    
    $('#pickupDate').flatpickr({
        minDate: 'today',
        dateFormat: 'Y/m/d',
        onChange: function(selectedDates, dateStr, instance) {
            aptReservations.pickupDate = dateStr;
        }
    });
    
    $('#returnDate').flatpickr({
        minDate: 'today',
        dateFormat: 'Y/m/d',
        onChange: function(selectedDates, dateStr, instance) {
            aptReservations.returnDate = dateStr;
        }
    });
    
    $('#departure-flight-date').flatpickr({
        minDate: 'today',
        dateFormat: 'Y/m/d',
        onChange: function(selectedDates, dateStr, instance) {
            aptReservations.departureFlightDate = dateStr;
        }
    });
    
    $('#arrival-flight-date').flatpickr({
        minDate: 'today',
        dateFormat: 'Y/m/d',
        onChange: function(selectedDates, dateStr, instance) {
            aptReservations.arrivalFlightDate = dateStr;
        }
    });

    function DatePicker(inputId, pickerId, onSelectDate) {
        this.input = document.getElementById(inputId);
        this.picker = document.getElementById(pickerId);
        this.selectedDate = null;
        this.currentDate = new Date();
        this.onSelectDate = onSelectDate; // Nueva propiedad
    
        // Métodos enlazados
        this.toggleCalendar = this.toggleCalendar.bind(this);
        this.closeCalendar = this.closeCalendar.bind(this);
        this.selectDate = this.selectDate.bind(this);
        this.previousMonth = this.previousMonth.bind(this);
        this.nextMonth = this.nextMonth.bind(this);
        this.buildCalendar = this.buildCalendar.bind(this);
        this.closeOnExternalClick = this.closeOnExternalClick.bind(this);
    
        // Inicializar
        this.init();
    }

      DatePicker.prototype.init = function() {
        this.input.addEventListener('click', this.toggleCalendar);
        document.addEventListener('click', this.closeOnExternalClick);
        this.buildCalendar();
      };
    
      DatePicker.prototype.toggleCalendar = function(event) {
        event.stopPropagation();
        this.picker.style.display = this.picker.style.display === 'block' ? 'none' : 'block';
      };
    
      DatePicker.prototype.closeCalendar = function() {
        this.picker.style.display = 'none';
      };
    
      DatePicker.prototype.closeOnExternalClick = function(event) {
        if (!this.picker.contains(event.target) && event.target !== this.input) {
          this.closeCalendar();
        }
      };
    
      DatePicker.prototype.selectDate = function(event) {
        const target = event.target;
        if (target.classList.contains('disabled') || target.textContent === '') return;
    
        const day = parseInt(target.textContent);
        this.selectedDate = new Date(this.currentDate.getFullYear(), this.currentDate.getMonth(), day);
        const formattedDate = this.formatDate(this.selectedDate);
        this.input.value = formattedDate;
        this.closeCalendar();
    
        // Actualizar aptReservations si es necesario
        if (typeof this.onSelectDate === 'function') {
            this.onSelectDate(formattedDate);
        }
    };
    
      DatePicker.prototype.previousMonth = function() {
        this.currentDate.setMonth(this.currentDate.getMonth() - 1);
        this.buildCalendar();
      };
    
      DatePicker.prototype.nextMonth = function() {
        this.currentDate.setMonth(this.currentDate.getMonth() + 1);
        this.buildCalendar();
      };
    
      DatePicker.prototype.isPastDate = function(day) {
        const today = new Date();
        today.setHours(0, 0, 0, 0);
        const checkDate = new Date(this.currentDate.getFullYear(), this.currentDate.getMonth(), day);
        return checkDate < today;
      };
    
      DatePicker.prototype.buildCalendar = function() {
        this.picker.innerHTML = '';
    
        // Encabezado del calendario
        const header = document.createElement('div');
        header.className = 'calendar-header';
    
        const prevBtn = document.createElement('i');
        prevBtn.className = 'fa fa-chevron-left';
    
        // Agregar manejador de evento con event.stopPropagation()
        prevBtn.addEventListener('click', (event) => {
            event.preventDefault();    // Prevenir la acción predeterminada
            event.stopPropagation();
            this.previousMonth();
        });
    
        const nextBtn = document.createElement('i');
        nextBtn.className = 'fa fa-chevron-right';
    
        // Agregar manejador de evento con event.stopPropagation()
        nextBtn.addEventListener('click', (event) => {
            event.stopPropagation();
            this.nextMonth();
        });
    
        const monthYear = document.createElement('div');
        monthYear.textContent = this.currentDate.toLocaleString('default', { month: 'long', year: 'numeric' });
    
        header.appendChild(prevBtn);
        header.appendChild(monthYear);
        header.appendChild(nextBtn);
        this.picker.appendChild(header);
    
        // Días de la semana
        const weekdays = document.createElement('div');
        weekdays.className = 'calendar-weekdays';
        const daysOfWeek = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'];
        daysOfWeek.forEach(day => {
          const dayDiv = document.createElement('div');
          dayDiv.textContent = day;
          weekdays.appendChild(dayDiv);
        });
        this.picker.appendChild(weekdays);
    
        // Días del mes
        const daysGrid = document.createElement('div');
        daysGrid.className = 'calendar-days';
        const firstDay = new Date(this.currentDate.getFullYear(), this.currentDate.getMonth(), 1).getDay();
        const totalDays = new Date(this.currentDate.getFullYear(), this.currentDate.getMonth() + 1, 0).getDate();
        const totalCells = Math.ceil((firstDay + totalDays) / 7) * 7;
    
        for (let i = 0; i < totalCells; i++) {
          const dayDiv = document.createElement('div');
          const dayNumber = i - firstDay + 1;
          if (i >= firstDay && dayNumber <= totalDays) {
            dayDiv.textContent = dayNumber;
            if (this.isPastDate(dayNumber)) {
              dayDiv.classList.add('disabled');
            } else {
              dayDiv.addEventListener('click', this.selectDate);
            }
          } else {
            dayDiv.textContent = '';
          }
          daysGrid.appendChild(dayDiv);
        }
        this.picker.appendChild(daysGrid);
    
        // Botón de cerrar
        const btnContainer = document.createElement('div');
        btnContainer.className = 'btn-container';
        const closeButton = document.createElement('button');
        closeButton.className = 'btn btn-primary';
        closeButton.textContent = 'Close';

        // Establecer el tipo del botón para prevenir que actúe como submit
        closeButton.setAttribute('type', 'button');

        closeButton.addEventListener('click', (event) => {
            event.preventDefault();    // Prevenir la acción predeterminada
            event.stopPropagation();   // Detener la propagación del evento
            this.closeCalendar();
        });
        btnContainer.appendChild(closeButton);
        this.picker.appendChild(btnContainer);
      };
    
      DatePicker.prototype.formatDate = function(date) {
        const options = { year: 'numeric', month: 'short', day: '2-digit' };
        return date.toLocaleDateString('en-US', options);
      };

      /* ||||||||||||||||||||||||||||||||||| FUNCIONES DATEPICKER ||||||||||||||||||||||||||||||||||||||| */

      /* ||||||||||||||||||||||||||||||||||| FUNCIONES TIMEPICKER ||||||||||||||||||||||||||||||||||||||| */

      function initializeTimePickers() {
        const timePickerConfigs = [
            {
                inputId: 'departureTime',
                pickerId: 'departureTimePicker',
                reservationKey: 'DepartureTime'
            },
            {
                inputId: 'pickupTime',
                pickerId: 'pickupTimePicker',
                reservationKey: 'pickupTime'
            },
            {
                inputId: 'returnTime',
                pickerId: 'returnTimePicker',
                reservationKey: 'returnTime'
            },
            {
                inputId: 'departure-pickup-time',
                pickerId: 'departurePickupTimePicker', // Asegúrate de que este ID existe en el HTML
                reservationKey: 'departurePickupTime'   // Asegúrate de que esta clave existe en aptReservations
            },
            // Añadidos los campos arrival-flight-time y departure-flight-time
            {
                inputId: 'arrival-flight-time',
                pickerId: 'arrivalFlightTimePicker', // Asegúrate de que este ID existe en el HTML
                reservationKey: 'arrivalFlightTime'
            },
            {
                inputId: 'departure-flight-time',
                pickerId: 'departureFlightTimePicker', // Asegúrate de que este ID existe en el HTML
                reservationKey: 'departureFlightTime'
            },
        ];
    
        timePickerConfigs.forEach(config => {
            if (document.getElementById(config.inputId)) {
                new TimePicker(config.inputId, config.pickerId, function(selectedTime) {
                    aptReservations[config.reservationKey] = selectedTime;
                });
            }
        });

        if (document.getElementById('departure-pickup-time')) {
            new TimePicker('departure-pickup-time', null, function(selectedTime) {
                aptReservations.DepartureTime = selectedTime;
            });
        }
    } 
     
      function TimePicker(inputId, pickerId, onSelectTime) {
        this.input = document.getElementById(inputId);
        this.picker = document.getElementById(pickerId);
        this.showTimePicker = false;
        this.selectedHour = 12;
        this.selectedMinute = 0;
        this.onSelectTime = onSelectTime; // Callback para actualizar aptReservations
    
        // Métodos enlazados
        this.toggleTimePicker = this.toggleTimePicker.bind(this);
        this.closeTimePicker = this.closeTimePicker.bind(this);
        this.closeOnExternalClick = this.closeOnExternalClick.bind(this);
        this.increaseHour = this.increaseHour.bind(this);
        this.decreaseHour = this.decreaseHour.bind(this);
        this.increaseMinute = this.increaseMinute.bind(this);
        this.decreaseMinute = this.decreaseMinute.bind(this);
        this.emitInput = this.emitInput.bind(this);
    
        // Inicializar
        this.init();
    }

    TimePicker.prototype.init = function() {
        // Evento para mostrar/ocultar el selector de tiempo
        this.input.addEventListener('click', this.toggleTimePicker);
    
        // Evento para cerrar el selector al hacer clic fuera
        document.addEventListener('click', this.closeOnExternalClick);
    
        // Inicializar la hora si el campo tiene un valor
        if (this.input.value) {
            const [hour, minute] = this.input.value.split(':');
            this.selectedHour = parseInt(hour);
            this.selectedMinute = parseInt(minute);
        }
    
        // Construir el selector de tiempo
        this.buildTimePicker();
        this.updateDisplayTime();
    };
    
    TimePicker.prototype.toggleTimePicker = function(event) {
        event.stopPropagation();
        this.showTimePicker = !this.showTimePicker;
        this.picker.style.display = this.showTimePicker ? 'block' : 'none';
    };
    
    TimePicker.prototype.closeTimePicker = function() {
        this.showTimePicker = false;
        this.picker.style.display = 'none';
    };
    
    TimePicker.prototype.closeOnExternalClick = function(event) {
        if (!this.picker.contains(event.target) && event.target !== this.input) {
            this.closeTimePicker();
        }
    };
    
    TimePicker.prototype.emitInput = function() {
        const newTime = `${this.formattedHour()}:${this.formattedMinute()}`;
        this.input.value = newTime;
        if (typeof this.onSelectTime === 'function') {
            this.onSelectTime(newTime);
        }
    };
    
    TimePicker.prototype.formattedHour = function() {
        return this.selectedHour.toString().padStart(2, '0');
    };
    
    TimePicker.prototype.formattedMinute = function() {
        return this.selectedMinute.toString().padStart(2, '0');
    };
    
    TimePicker.prototype.updateDisplayTime = function() {
        this.input.value = `${this.formattedHour()}:${this.formattedMinute()}`;
    };
    
    TimePicker.prototype.increaseHour = function(event) {
        event.stopPropagation();
        this.selectedHour = (this.selectedHour + 1) % 24;
        this.updateTimeDisplay();
    };
    
    TimePicker.prototype.decreaseHour = function(event) {
        event.stopPropagation();
        this.selectedHour = (this.selectedHour - 1 + 24) % 24;
        this.updateTimeDisplay();
    };
    
    TimePicker.prototype.increaseMinute = function(event) {
        event.stopPropagation();
        this.selectedMinute = (this.selectedMinute + 5) % 60;
        this.updateTimeDisplay();
    };
    
    TimePicker.prototype.decreaseMinute = function(event) {
        event.stopPropagation();
        this.selectedMinute = (this.selectedMinute - 5 + 60) % 60;
        this.updateTimeDisplay();
    };
    
    TimePicker.prototype.updateTimeDisplay = function() {
        // Actualizar el encabezado del selector de tiempo
        const timeHeader = this.picker.querySelector('.time-header span');
        timeHeader.textContent = `${this.formattedHour()} : ${this.formattedMinute()}`;
    
        // Actualizar el campo de entrada y aptReservations
        this.emitInput();
    };
    
    TimePicker.prototype.buildTimePicker = function() {
        this.picker.innerHTML = '';
    
        // Encabezado del selector de tiempo
        const timeHeader = document.createElement('div');
        timeHeader.className = 'time-header';
    
        const timeDisplay = document.createElement('span');
        timeDisplay.className = 'mx-4';
        timeDisplay.textContent = `${this.formattedHour()} : ${this.formattedMinute()}`;
    
        timeHeader.appendChild(timeDisplay);
        this.picker.appendChild(timeHeader);
    
        // Controles de hora y minuto
        const timeControls = document.createElement('div');
        timeControls.className = 'time-controls my-3';
    
        // Control de horas
        const hourControl = document.createElement('div');
        hourControl.className = 'time-control-item';
    
        const decreaseHourBtn = document.createElement('button');
        decreaseHourBtn.className = 'btn btn-primary';
        decreaseHourBtn.type = 'button';
        decreaseHourBtn.textContent = '-';
        decreaseHourBtn.addEventListener('click', this.decreaseHour);
    
        const hourLabel = document.createElement('span');
        hourLabel.className = 'mx-1';
        hourLabel.style.lineHeight = '2em';
        hourLabel.textContent = 'hours';
    
        const increaseHourBtn = document.createElement('button');
        increaseHourBtn.className = 'btn btn-primary';
        increaseHourBtn.type = 'button';
        increaseHourBtn.textContent = '+';
        increaseHourBtn.addEventListener('click', this.increaseHour);
    
        hourControl.appendChild(decreaseHourBtn);
        hourControl.appendChild(hourLabel);
        hourControl.appendChild(increaseHourBtn);
    
        // Control de minutos
        const minuteControl = document.createElement('div');
        minuteControl.className = 'time-control-item';
    
        const decreaseMinuteBtn = document.createElement('button');
        decreaseMinuteBtn.className = 'btn btn-primary';
        decreaseMinuteBtn.type = 'button';
        decreaseMinuteBtn.textContent = '-';
        decreaseMinuteBtn.addEventListener('click', this.decreaseMinute);
    
        const minuteLabel = document.createElement('span');
        minuteLabel.className = 'mx-1';
        minuteLabel.style.lineHeight = '2em';
        minuteLabel.textContent = 'minutes';
    
        const increaseMinuteBtn = document.createElement('button');
        increaseMinuteBtn.className = 'btn btn-primary';
        increaseMinuteBtn.type = 'button';
        increaseMinuteBtn.textContent = '+';
        increaseMinuteBtn.addEventListener('click', this.increaseMinute);
    
        minuteControl.appendChild(decreaseMinuteBtn);
        minuteControl.appendChild(minuteLabel);
        minuteControl.appendChild(increaseMinuteBtn);
    
        // Agregar controles al contenedor
        timeControls.appendChild(hourControl);
        timeControls.appendChild(minuteControl);
        this.picker.appendChild(timeControls);
    
        // Botón de cerrar
        const btnContainer = document.createElement('div');
        btnContainer.className = 'btn-container';
    
        const closeButton = document.createElement('button');
        closeButton.className = 'btn btn-primary';
        closeButton.type = 'button';
        closeButton.textContent = 'Close';
        closeButton.addEventListener('click', (event) => {
            event.preventDefault();
            event.stopPropagation();
            this.closeTimePicker();
        });
    
        btnContainer.appendChild(closeButton);
        this.picker.appendChild(btnContainer);
    };

    /* ||||||||||||||||||||||||||||||||||| FUNCIONES TIMEPICKER ||||||||||||||||||||||||||||||||||||||| */

    /* ||||||||||||||||||||||||||||||||||| FUNCIONES VEHICLES ||||||||||||||||||||||||||||||||||||||| */

    // Mostrar y ocultar el spinner de carga de vehículos
    function showVehiclesLoadingSpinner() {
        $('#vehicles-loading-spinner').show();
        $('#vehicles-container').hide();
    }

    function hideVehiclesLoadingSpinner() {
        $('#vehicles-loading-spinner').hide();
        $('#vehicles-container').show();
    }

    async function getFleet() {
        try {
            console.log('getFleet iniciado...');
            showVehiclesLoadingSpinner();
            const userCompany = aptReservations.company_id;
            let fleet = [];
            let vehicleIds = [];
    
            // Obtener la flota de vehículos desde la API
            const API_URL = `${apiURL}public/search-company-vehicles`;
            const headers = {
                'Accept': 'application/json',
                'Content-Type': 'application/json',
                'User-Company': userCompany
            };
    
            const response = await fetch(API_URL, {
                method: 'GET',
                headers: headers
            });
    
            const data = await response.json();
    
            if (data && data.data) {
                fleet = data.data.filter(item => item.vehiclePerCompany_status === 1);
                vehicleIds = fleet.map(v => v.vehiclePerCompany_id);
            }
    
            aptReservations.fleet = fleet;
    
            await getRates(vehicleIds);
    
            matchFleetWithRates();
    
            renderFleet();
    
            hideVehiclesLoadingSpinner();
    
        } catch (error) {
            console.error('Error during getFleet:', error);
            hideVehiclesLoadingSpinner();
            displayVehiclesErrors(['Error loading vehicles. Please try again later.']);
        }
    }

    async function getRates(vehiclePerCompany_ids) {
        try {
            showVehiclesLoadingSpinner();
    
            let arrivalDate = '';
            let departureDate = '';
            const isOriginAirport = aptReservations.isOriginAirport;
            const isDestinationAirport = aptReservations.isDestinationAirport;
    
            if (isOriginAirport === true || isDestinationAirport === true) {
                arrivalDate = aptReservations.ArrivalDate;
                departureDate = aptReservations.DepartureDate;
            } else {
                arrivalDate = aptReservations.pickupDate;
                departureDate = aptReservations.returnDate;
            }
    
            let isArrival = aptReservations.isArrival;
            let isDeparture = aptReservations.isDeparture;
            const zonePerCompanyId = aptReservations.selectedGeofence;
            const companyId = aptReservations.company_id;
            const originZone = aptReservations.originZone;
            const destinationZone = aptReservations.destinationZone;
            const serviceType = aptReservations.serviceType;
            const destinationID = aptReservations.destinationID;
    
            if (serviceType === "2") {
                isArrival = true;
                isDeparture = true;
            }
    
            // Convertir el arreglo de IDs a JSON
            const vehicleIDSJson = JSON.stringify(vehiclePerCompany_ids);
    
            // Configurar la llamada a la API
            const API_URL = `${apiURL}public/search-company-transportation-rates`;
    
            const headers = {
                'Accept': 'application/json',
                'Content-Type': 'application/json',
                'Rate-Arrival': arrivalDate,
                'Rate-Departure': departureDate,
                'Rate-Company': companyId,
                'Rate-Zone': zonePerCompanyId,
                'isArrival': isArrival,
                'isDeparture': isDeparture,
                'fromZone': originZone,
                'toZone': destinationZone,
                'serviceType': serviceType,
                'destinationID': destinationID,
                'vehicleIDS': vehicleIDSJson
            };
    
            const response = await fetch(API_URL, {
                method: 'GET',
                headers: headers
            });
    
            const data = await response.json();
    
            if ('errors' in data) {
                throw new Error('Error fetching rates');
            }
    
            // Almacenar las tarifas en aptReservations
            aptReservations.vehicleRates = data.data.reduce((acc, rate) => {
                acc[rate.vehiclePerCompany_id] = rate;
                return acc;
            }, {});
    
            console.log('vehicleRates', aptReservations.vehicleRates);
    
            hideVehiclesLoadingSpinner();
    
        } catch (error) {
            console.error('Error during getRates:', error);
            hideVehiclesLoadingSpinner();
            displayVehiclesErrors(['Error loading vehicle rates. Please try again later.']);
        }
    }
    
    // Mostrar errores en la pestaña de vehículos
    function displayVehiclesErrors(errors) {
        const errorsContainer = $('#vehicles-errors');
        errorsContainer.html(errors.join('<br>')).show();
    }

    function matchFleetWithRates() {
        const totalPAX = parseInt(aptReservations.adults) + parseInt(aptReservations.kids) + parseInt(aptReservations.infants);
        const fleet = aptReservations.fleet;
        const vehicleRates = aptReservations.vehicleRates;
    
        aptReservations.fleet = fleet.map(vehicle => {
            const vehiclesNeeded = Math.ceil(totalPAX / vehicle.vehiclePerCompany_seats);
    
            const vehicleRateInfo = vehicleRates[vehicle.vehiclePerCompany_id];
    
            if (vehicleRateInfo && vehicleRateInfo.rate) {
                vehicle.baseRate = vehicleRateInfo.rate;
            } else {
                console.log(`No rates found for vehicle ID ${vehicle.vehiclePerCompany_id}, using base rate.`);
                vehicle.baseRate = vehicle.vehiclePerCompany_base_rate;
            }
    
            vehicle.vehiclesNeeded = vehiclesNeeded;
    
            // Aplicar cupón si es necesario (ajusta esta lógica según tus necesidades)
            if (aptReservations.couponAlreadyApplied === 1) {
                if (aptReservations.PRE_coupon_type === 1) {
                    vehicle.vehicleRate = vehicle.baseRate - aptReservations.PRE_coupon_amount;
                } else if (aptReservations.PRE_coupon_type === 2) {
                    vehicle.vehicleRate = vehicle.baseRate - (vehicle.baseRate * aptReservations.PRE_coupon_amount / 100);
                }
            } else {
                vehicle.vehicleRate = vehicle.baseRate;
            }
    
            // Formatear las tarifas a dos decimales
            vehicle.baseRate = parseFloat(vehicle.baseRate).toFixed(2);
            vehicle.vehicleRate = parseFloat(vehicle.vehicleRate).toFixed(2);
    
            return vehicle;
        });
    }
    
    function renderFleet() {
        const fleetContainer = $('#vehicles-container');
        fleetContainer.empty(); // Limpiar contenido existente
    
        const fleet = aptReservations.fleet;
        const totalPAX = parseInt(aptReservations.adults) + parseInt(aptReservations.kids) + parseInt(aptReservations.infants);
    
        if (fleet.length === 0) {
            fleetContainer.html('<p>No vehicles available.</p>');
            return;
        }
    
        fleet.forEach(vehicle => {
            const vehicleHTML = `
                <div class="col-md-3 col-sm-6 mb-5">
                    <div class="card pt-3 mx-1 px-3">
                        <div class="card-content">
                            ${vehicle.vehiclePerCompany_custom_image ? `<img src="${vehicle.vehiclePerCompany_custom_image}" class="img-fluid" style="height:120px">` : `<img src="${vehicle.vehicle.vehicle_image}" class="img-fluid" width="90%">`}
                            <h6 class="mt-2">${vehicle.vehicle.vehicle_make} ${vehicle.vehicle.vehicle_model}</h6>
                            <p class="mb-1" style="color: #ccc; font-size:0.7em;"><i class="fa-solid fa-arrow-right-long"></i> ${vehicle.vehiclePerCompany_seats} <i class="fa-solid fa-user"></i></p>
                            ${aptReservations.couponAlreadyApplied === 1 ? `
                                <h4 class="base-rate" style="margin-bottom: 5px;">$${vehicle.baseRate} <span class="lighter-gray">USD</span></h4>
                                <h4 class="new-rate">$${vehicle.vehicleRate} <span class="lighter-gray">USD</span></h4>
                            ` : `
                                <h4 style="font-weight: 600;">$${vehicle.baseRate} <span class="lighter-gray">USD</span></h4>
                            `}
                            <button onclick="submitFleet(${vehicle.vehiclePerCompany_id}, ${vehicle.vehicleRate}, '${vehicle.vehicle.vehicle_make}', '${vehicle.vehicle.vehicle_model}')" style="background-color: var(--company-color) !important; border-color: var(--company-color) !important;" type="button" class="btn btn-primary mt-2 mb-4">
                                Select vehicle
                            </button>
                            ${vehicle.vehiclesNeeded > 1 ? `<div class="vehiclesNeeded_alert">Please consider you might need ${vehicle.vehiclesNeeded} of these vehicles since your reservation will be for ${totalPAX} passengers.</div>` : ''}
                        </div>
                    </div>
                </div>
            `;
            fleetContainer.append(vehicleHTML);
        });
    }

    window.submitFleet = function(vehiclePerCompanyId, amount, make, model) {
        let totalPAX = parseInt(aptReservations.adults) + parseInt(aptReservations.kids) + parseInt(aptReservations.infants);
        let selectedVehicle = aptReservations.fleet.find(item => item.vehiclePerCompany_id === vehiclePerCompanyId);
        let vehiclesNeeded = Math.ceil(totalPAX / selectedVehicle.vehiclePerCompany_seats);
        let subtotal = amount * vehiclesNeeded;
    
        let submissionData = {
            vehicles: {
                vehiclePerCompany_id: vehiclePerCompanyId,
                make: make,
                model: model,
                totalAmount: subtotal,
                Quantity: vehiclesNeeded
            },
            subtotal: subtotal
        };
    
        Object.assign(aptReservations, submissionData);
    
        // Cambiar a la siguiente pestaña (addons)
        activateTab('addons');
    }

    // Manejador de evento para el botón "Back" en la pestaña "vehicles"
    $('#vehicles-back-button').on('click', function() {
        goBackFromVehicles();
    });

    // Función para manejar el regreso a la pestaña anterior
    function goBackFromVehicles() {
        activateTab('calendar');
    }

    /* ||||||||||||||||||||||||||||||||||| FUNCIONES VEHICLES ||||||||||||||||||||||||||||||||||||||| */

    /* ||||||||||||||||||||||||||||||||||| FUNCIONES ADDONS ||||||||||||||||||||||||||||||||||||||| */

    function showAddonsLoadingSpinner() {
        $('#addons-loading-spinner').show();
        $('#addons-container').hide();
    }
    
    function hideAddonsLoadingSpinner() {
        $('#addons-loading-spinner').hide();
        $('#addons-container').show();
    }

    function displayAddonsErrors(errors) {
        const errorsContainer = $('#addons-errors');
        errorsContainer.html(errors.join('<br>')).show();
    }

    async function getAddons() {
        try {
            showAddonsLoadingSpinner();
            const userCompany = aptReservations.company_id;
            const API_URL = `${apiURL}public/search-company-transportation-addons`;
    
            const headers = {
                'Accept': 'application/json',
                'Content-Type': 'application/json',
                'User-Company': userCompany
            };
    
            const response = await fetch(API_URL, {
                method: 'GET',
                headers: headers
            });
    
            const data = await response.json();
    
            if ('errors' in data) {
                throw new Error('Error fetching addons');
            }
    
            // Filtrar addons activos
            aptReservations.addonsAvailable = data.data.filter(item => item.TransportationAddon_status === 1);
    
            // Inicializar selectedAddons
            aptReservations.selectedAddons = {};
            aptReservations.addonsAvailable.forEach(addon => {
                aptReservations.selectedAddons[addon.TransportationAddon_id] = {
                    id: addon.TransportationAddon_id,
                    quantity: 0,
                    rate: addon.TransportationAddon_rate,
                };
            });
    
            renderAddons();
    
            hideAddonsLoadingSpinner();
    
        } catch (error) {
            console.error('Error during getAddons:', error);
            hideAddonsLoadingSpinner();
            displayAddonsErrors(['Error loading addons. Please try again later.']);
        }
    }

    function renderAddons() {
        const addonsContainer = $('#addons-container');
        addonsContainer.empty(); // Limpiar contenido existente
    
        const addons = aptReservations.addonsAvailable;
    
        if (!addons || addons.length === 0) {
            addonsContainer.html('<p>No additional products available.</p>');
            return;
        }
    
        addons.forEach(addon => {
            const addonHTML = `
                <div class="col-md-3 col-sm-6 mb-5">
                    <div class="card pt-3 mx-1 px-3">
                        <div class="card-content">
                            ${addon.TransportationAddon_image ? `<img src="${addon.TransportationAddon_image}" class="img-fluid" style="width:100%; max-height: 130px;">` : ''}
                            <h5 class="mt-3">${addon.TransportationAddon_title}</h5>
                            <p class="mb-4" style="font-size: 0.8em;">${addon.TransportationAddon_description}</p>
                        </div>
                        <h4 class="price" style="font-weight: 600;">$${addon.TransportationAddon_rate} <span class="lighter-gray" style="font-size: 0.7em;">USD</span></h4>
                        <div class="form-group">
                            <label for="addon-quantity-${addon.TransportationAddon_id}">Quantity</label>
                            <input type="number" id="addon-quantity-${addon.TransportationAddon_id}" class="form-control addon-quantity" data-addon-id="${addon.TransportationAddon_id}" min="0" value="0">
                        </div>
                    </div>
                </div>
            `;
            addonsContainer.append(addonHTML);
        });
    
        // Manejador de evento para cambios en las cantidades de los addons
        $('.addon-quantity').on('change', function() {
            const addonId = $(this).data('addon-id');
            const quantity = parseInt($(this).val());
    
            // Actualizar aptReservations.selectedAddons
            if (quantity > 0) {
                aptReservations.selectedAddons[addonId].quantity = quantity;
            } else {
                aptReservations.selectedAddons[addonId].quantity = 0;
            }
        });
    }    

    // Botón "Back" en la pestaña "addons"
    $('#addons-back-button').on('click', function() {
        activateTab('vehicles');
    });

    // Botón "Next" en la pestaña "addons"
    $('#addons-next-button').on('click', function() {
        submitAddons();
    });

    function submitAddons() {
        let errors = [];
        let addonsTotal = 0;
    
        // Filtrar addons seleccionados
        const selectedAddons = Object.values(aptReservations.selectedAddons).filter(addon => addon.quantity > 0);
    
        aptReservations.addons = []; // Reiniciar el array de addons seleccionados
    
        selectedAddons.forEach(addon => {
            const fullAddon = aptReservations.addonsAvailable.find(a => a.TransportationAddon_id === addon.id);
    
            let addonObject = {
                id: addon.id,
                title: fullAddon.TransportationAddon_title,
                quantity: addon.quantity,
                rate: addon.rate,
                total: addon.rate * addon.quantity,
            };
    
            // Agregar el addon a aptReservations.addons
            aptReservations.addons.push(addonObject);
            addonsTotal += addonObject.total;
        });
    
        // Calcular subtotales y totales
        aptReservations.subtotal = parseFloat(aptReservations.vehicles.totalAmount) + parseFloat(addonsTotal);
    
        // Aplicar impuestos si corresponde
        const bookingOptions = companyData.booking_options[0];
        if (bookingOptions.bookingOptions_transportation_tax_status === 1) {
            aptReservations.tax = bookingOptions.bookingOptions_transportation_tax;
            aptReservations.tax_amount = aptReservations.subtotal * (aptReservations.tax / 100);
            aptReservations.total = aptReservations.subtotal + aptReservations.tax_amount;
        } else {
            aptReservations.total = aptReservations.subtotal;
        }
    
        // Avanzar a la siguiente pestaña
        activateTab('client');
    }

    /* ||||||||||||||||||||||||||||||||||| FUNCIONES ADDONS ||||||||||||||||||||||||||||||||||||||| */

    /* ||||||||||||||||||||||||||||||||||| FUNCIONES CLIENTS ||||||||||||||||||||||||||||||||||||||| */

    // Global variables
    let stripe;
    let elements;
    let cardNumberElement, cardExpiryElement, cardCvcElement;

    function initializeClientTab() {
        console.log('initializeClientTab called');
        console.log('companyData:', companyData);
    
        // Mostrar u ocultar campos de pago según sea necesario
        updatePaymentFields();
        setupStripeElements();
        updateFlightDetails();
        displayAptReservations();
    
        // Configurar manejadores de eventos para el formulario de cliente
        $('#client-form').off('submit').on('submit', handleClientFormSubmit);
        
    }    

    // Function to set up Stripe Elements
    function setupStripeElements() {
        console.log('setupStripeElements called');
        // Asegurarse de que companyData y su propiedad payment_platforms[0] existen
        if (companyData && companyData.payment_platforms && companyData.payment_platforms[0] && companyData.payment_platforms[0].stripe_live_key) {
            const stripePublicKey = companyData.payment_platforms[0].stripe_live_key;
            console.log('Stripe public key:', stripePublicKey);
    
            stripe = Stripe(stripePublicKey);
            elements = stripe.elements();
    
            const style = {
                base: {
                    fontSize: '16px',
                    lineHeight: '22px',
                    fontFamily: 'Poppins, Arial, sans-serif',
                },
                invalid: {
                    color: '#fa755a',
                    iconColor: '#fa755a',
                },
            };
    
            // Crear elementos individuales para cada parte de la tarjeta
            cardNumberElement = elements.create('cardNumber', { style });
            cardNumberElement.mount('#card-number-element');
    
            cardExpiryElement = elements.create('cardExpiry', { style });
            cardExpiryElement.mount('#card-expiry-element');
    
            cardCvcElement = elements.create('cardCvc', { style });
            cardCvcElement.mount('#card-cvc-element');
    
        } else {
            console.error('Stripe public key not found in companyData');
            // Manejar el error apropiadamente, quizás mostrar un mensaje al usuario
        }
    }

    // Manejador para el botón "Back" en la pestaña "client"
    $('#client-back-button').on('click', function() {
        activateTab('addons');
    });

    // Initialize Stripe Elements when the client tab is shown
    $('#client-tab').on('shown.bs.tab', async function() {
        await setupStripeElements();
    });

    // Show payment fields when appropriate
    function updatePaymentFields() {
        if (!aptReservations.allyCode) {
            $('#payment-fields').show();
        } else {
            $('#payment-fields').hide();
        }
    }    

    // Update payment fields when the client tab is shown
    $('#client-tab').on('shown.bs.tab', function() {
        updatePaymentFields();
        updateFlightDetails();
    });

    // Show flight details fields if needed
    function updateFlightDetails() {
        console.log('updateFlightDetails called');
        console.log('isOriginAirport:', aptReservations.isOriginAirport);
        console.log('isDestinationAirport:', aptReservations.isDestinationAirport);
        console.log('serviceType:', aptReservations.serviceType);
    
        if (aptReservations.isOriginAirport || aptReservations.isDestinationAirport) {
            $('#flight-details').show();
            let flightDetailsHtml = '';
    
            if (aptReservations.serviceType === 1) { // One Way
                if (aptReservations.isOriginAirport) {
                    // Mostrar Arrival Flight
                    flightDetailsHtml += `
                        <div class="row mb-3">
                            <div class="col-md-3">
                                <label for="arrival-airline" class="form-label">Arrival Airline</label>
                                <select class="form-select" id="arrival-airline">
                                    <option value="">Select an airline</option>
                                    ${generateAirlineOptions()}
                                </select>
                            </div>
                            <div class="col-md-3">
                                <label for="arrival-flight-number" class="form-label">Flight Number</label>
                                <input type="text" class="form-control" id="arrival-flight-number" placeholder="E.g. AM04">
                            </div>
                            <div class="col-md-3">
                                <label for="arrival-flight-date">Arrival Flight Date</label>
                                <input type="text" id="arrival-flight-date" class="form-control date-picker-input" placeholder="Select Arrival Flight Date" readonly>
                                <div id="arrivalFlightDatePicker" class="datepicker-container" style="display: none;"></div>
                            </div>
                            <div class="col-md-3">
                                <label for="arrival-flight-time">Arrival Flight Time</label>
                                <input type="text" id="arrival-flight-time" class="form-control time-picker-input" placeholder="Select Arrival Flight Time" readonly>
                                <div id="arrivalFlightTimePicker" class="timepicker-container" style="display: none;"></div>
                            </div>
                        </div>
                        <hr width="100%" class="mt-4 mb-4"> <!-- Separación -->
                    `;
                }
    
                if (aptReservations.isDestinationAirport) {
                    // Mostrar Departure Flight
                    flightDetailsHtml += `
                        <div class="row mb-3">
                            <div class="col-md-3">
                                <label for="departure-airline" class="form-label">Departure Airline</label>
                                <select class="form-select" id="departure-airline">
                                    <option value="">Select an airline</option>
                                    ${generateAirlineOptions()}
                                </select>
                            </div>
                            <div class="col-md-3">
                                <label for="departure-flight-number" class="form-label">Flight Number</label>
                                <input type="text" class="form-control" id="departure-flight-number" placeholder="E.g. AM04">
                            </div>
                            <div class="col-md-3">
                                <label for="departure-flight-date">Departure Flight Date</label>
                                <input type="text" id="departure-flight-date" class="form-control date-picker-input" placeholder="Select Departure Flight Date" readonly>
                                <div id="departureFlightDatePicker" class="datepicker-container" style="display: none;"></div>
                            </div>
                            <div class="col-md-3">
                                <label for="departure-flight-time">Departure Flight Time</label>
                                <input type="text" id="departure-flight-time" class="form-control time-picker-input" placeholder="Select Departure Flight Time" readonly>
                                <div id="departureFlightTimePicker" class="timepicker-container" style="display: none;"></div>
                            </div>
                        </div>
                        <hr width="100%" class="mt-4 mb-4"> <!-- Separación -->
                    `;
                }
            } else if (aptReservations.serviceType === 2) { // Round Trip
                // Mostrar ambos campos de Arrival y Departure Flight
                flightDetailsHtml += `
                    <div class="row mb-3">
                        <div class="col-md-3">
                            <label for="arrival-airline" class="form-label">Arrival Airline</label>
                            <select class="form-select" id="arrival-airline">
                                <option value="">Select an airline</option>
                                ${generateAirlineOptions()}
                            </select>
                        </div>
                        <div class="col-md-3">
                            <label for="arrival-flight-number" class="form-label">Flight Number</label>
                            <input type="text" class="form-control" id="arrival-flight-number" placeholder="E.g. AM04">
                        </div>
                        <div class="col-md-3">
                            <label for="arrival-flight-date">Arrival Flight Date</label>
                            <input type="text" id="arrival-flight-date" class="form-control date-picker-input" placeholder="Select Arrival Flight Date" readonly>
                            <div id="arrivalFlightDatePicker" class="datepicker-container" style="display: none;"></div>
                        </div>
                        <div class="col-md-3">
                            <label for="arrival-flight-time">Arrival Flight Time</label>
                            <input type="text" id="arrival-flight-time" class="form-control time-picker-input" placeholder="Select Arrival Flight Time" readonly>
                            <div id="arrivalFlightTimePicker" class="timepicker-container" style="display: none;"></div>
                        </div>
                    </div>
                    <div class="row mb-3">
                        <div class="col-md-3">
                            <label for="departure-airline" class="form-label">Departure Airline</label>
                            <select class="form-select" id="departure-airline">
                                <option value="">Select an airline</option>
                                ${generateAirlineOptions()}
                            </select>
                        </div>
                        <div class="col-md-3">
                            <label for="departure-flight-number" class="form-label">Flight Number</label>
                            <input type="text" class="form-control" id="departure-flight-number" placeholder="E.g. AM04">
                        </div>
                        <div class="col-md-3">
                            <label for="departure-flight-date">Departure Flight Date</label>
                            <input type="text" id="departure-flight-date" class="form-control date-picker-input" placeholder="Select Departure Flight Date" readonly>
                            <div id="departureFlightDatePicker" class="datepicker-container" style="display: none;"></div>
                        </div>
                        <div class="col-md-3">
                            <label for="departure-flight-time">Departure Flight Time</label>
                            <input type="text" id="departure-flight-time" class="form-control time-picker-input" placeholder="Select Departure Flight Time" readonly>
                            <div id="departureFlightTimePicker" class="timepicker-container" style="display: none;"></div>
                        </div>
                    </div>
                    <hr width="100%" class="mt-4 mb-4"> <!-- Separación -->
                `;
            }
    
            // Añadir el HTML generado al contenedor
            $('#flight-details').html(flightDetailsHtml);
    
            // Inicializar los DatePickers y TimePickers para los nuevos campos
            initializeDatePickers();
            initializeTimePickers();
    
            // Inicializar tooltips si es necesario
            setupTooltip();
    
            console.log('Flight details HTML injected');
        } else {
            // Ocultar los campos de vuelo si no es transporte de aeropuerto
            $('#flight-details').hide();
            $('#flight-details').empty();
        }
    }           

    function generateAirlineOptions() {
        const airlines = [
            { id: 1, name: 'Aer Lingus' },
            { id: 2, name: 'Aero Republica' },
            { id: 3, name: 'Aeroenlaces Nacionales' },
            { id: 4, name: 'Aeroméxico' },
            { id: 5, name: 'Air Algerie' },
            { id: 6, name: 'Air Berlin' },
            { id: 7, name: 'Air Canada' },
            { id: 8, name: 'Air China' },
            { id: 9, name: 'Air Europa' },
            { id: 10, name: 'Air France' },
            { id: 11, name: 'Air India' },
            { id: 12, name: 'Air Jamaica' },
            { id: 13, name: 'Air New Zealand' },
            { id: 14, name: 'Air Pacific' },
            { id: 15, name: 'Air Tahiti Nui' },
            { id: 16, name: 'Air Transat' },
            { id: 17, name: 'Air Zimbabwe' },
            { id: 18, name: 'Aircalin' },
            { id: 19, name: 'Alaska Airlines' },
            { id: 20, name: 'Alitalia' },
            { id: 21, name: 'All Nippon Airways' },
            { id: 22, name: 'American Airlines' },
            { id: 23, name: 'Arajet' },
            { id: 24, name: 'Asiana Airlines' },
            { id: 25, name: 'Austrian Airlines' },
            { id: 26, name: 'Avianca' },
            { id: 27, name: 'Bangkok Airways' },
            { id: 28, name: 'British Airways' },
            { id: 29, name: 'Brussels Airlines' },
            { id: 30, name: 'Cathay Pacific Airways' },
            { id: 31, name: 'China Airlines' },
            { id: 32, name: 'China Eastern Airlines' },
            { id: 33, name: 'China Southern Airlines' },
            { id: 34, name: 'Copa Airlines' },
            { id: 35, name: 'Croatia Airlines' },
            { id: 36, name: 'Czech Airlines' },
            { id: 37, name: 'Delta Air Lines' },
            { id: 38, name: 'Egyptair' },
            { id: 39, name: 'El Al Israel Airlines' },
            { id: 40, name: 'Emirates' },
            { id: 41, name: 'Ethiopian Airlines' },
            { id: 42, name: 'Etihad Airways' },
            { id: 43, name: 'EVA Air' },
            { id: 44, name: 'Fiji Airways' },
            { id: 45, name: 'Finnair' },
            { id: 46, name: 'Flair Airlines' },
            { id: 47, name: 'Frontier Airlines' },
            { id: 48, name: 'Garuda Indonesia' },
            { id: 49, name: 'Gulf Air' },
            { id: 50, name: 'Hawaiian Airlines' },
            { id: 51, name: 'Iberia' },
            { id: 52, name: 'Icelandair' },
            { id: 53, name: 'Japan Airlines' },
            { id: 54, name: 'Jet Airways' },
            { id: 55, name: 'JetBlue Airways' },
            { id: 56, name: 'Kenya Airways' },
            { id: 57, name: 'KLM Royal Dutch Airlines' },
            { id: 58, name: 'Korean Air' },
            { id: 59, name: 'LAN Airlines' },
            { id: 60, name: 'LOT Polish Airlines' },
            { id: 61, name: 'Lufthansa' },
            { id: 62, name: 'Malaysia Airlines' },
            { id: 63, name: 'Middle East Airlines' },
            { id: 64, name: 'Olympic Air' },
            { id: 65, name: 'Pakistan International Airlines' },
            { id: 66, name: 'Philippine Airlines' },
            { id: 67, name: 'Qantas Airways' },
            { id: 68, name: 'Qatar Airways' },
            { id: 69, name: 'Royal Air Maroc' },
            { id: 70, name: 'Royal Brunei Airlines' },
            { id: 71, name: 'Royal Jordanian' },
            { id: 72, name: 'SAS Scandinavian Airlines' },
            { id: 73, name: 'Saudi Arabian Airlines' },
            { id: 74, name: 'Señor Air' },
            { id: 75, name: 'Shanghai Airlines' },
            { id: 76, name: 'Siberia Airlines' },
            { id: 77, name: 'Singapore Airlines' },
            { id: 78, name: 'South African Airways' },
            { id: 79, name: 'Southwest Airlines' },
            { id: 80, name: 'Spirit Airlines' },
            { id: 81, name: 'SriLankan Airlines' },
            { id: 103, name: 'Sun Country Airlines' },
            { id: 82, name: 'Sunwing Airlines' },
            { id: 83, name: 'Swiss International Air Lines' },
            { id: 84, name: 'TACA Airlines' },
            { id: 85, name: 'TAM Airlines' },
            { id: 86, name: 'TAP Portugal' },
            { id: 87, name: 'TAR Aerolineas' },
            { id: 88, name: 'Thai Airways' },
            { id: 89, name: 'Transaero Airlines' },
            { id: 90, name: 'Tunisair' },
            { id: 91, name: 'Turkish Airlines' },
            { id: 92, name: 'United Airlines' },
            { id: 93, name: 'US Airways' },
            { id: 94, name: 'Uzbekistan Airways' },
            { id: 95, name: 'Vietnam Airlines' },
            { id: 96, name: 'Virgin America' },
            { id: 97, name: 'Virgin Atlantic' },
            { id: 98, name: 'Virgin Australia' },
            { id: 99, name: 'VivaAerobus' },
            { id: 100, name: 'Volaris' },
            { id: 101, name: 'WestJet' },
            { id: 102, name: 'Xiamen Airlines' },
          ];
    
        return airlines.map(airline => `<option value="${airline.name}">${airline.name}</option>`).join('');
    }

    function setupTooltip() {
        $('.position-relative').hover(
            function() {
                $(this).find('.info-box').css({ visibility: 'visible', opacity: 1 });
            },
            function() {
                $(this).find('.info-box').css({ visibility: 'hidden', opacity: 0 });
            }
        );
    }

    $('#apply-coupon-button').on('click', function() {
        applyCoupon();
    });
    
    async function applyCoupon() {
        const couponCode = $('#promoCode').val().trim();
        if (!couponCode) {
            $('#coupon-error').text('No coupon code has been entered');
            return;
        }
    
        $('#coupon-spinner').show();
        $('#coupon-error').text('');
        $('#coupon-success').text('');
    
        try {
            const response = await fetch(`${apiURL}public/find-coupon/${couponCode}`, {
                method: 'GET',
                headers: {
                    'Accept': 'application/json',
                    'Content-Type': 'application/json',
                    'Company-ID': aptReservations.company_id
                }
            });
            const data = await response.json();
    
            if (data.error) {
                $('#coupon-error').text(data.error);
            } else {
                // Apply the coupon to aptReservations
                aptReservations.couponAmount = data.data.coupon_amount;
                aptReservations.couponType = data.data.coupon_type;
                aptReservations.coupon_apply_on = data.data.coupon_apply_on;
                aptReservations.promoCode = couponCode;
                aptReservations.couponApplied = true;
    
                // Recalculate total
                recalculateTotal();
    
                $('#coupon-success').text('Coupon code applied successfully');
            }
        } catch (error) {
            console.error('Error applying coupon:', error);
            $('#coupon-error').text('Error applying coupon. Please try again later.');
        } finally {
            $('#coupon-spinner').hide();
        }
    }
    
    function recalculateTotal() {
        let totalWithCoupon = aptReservations.originalTotal || aptReservations.total;
    
        if (aptReservations.couponType === 2) { // Descuento porcentual
            let amountDiscount;
            if (aptReservations.coupon_apply_on === 2) { // Aplicar sobre el subtotal
                amountDiscount = (totalWithCoupon * aptReservations.couponAmount) / 100;
            } else if (aptReservations.coupon_apply_on === 1) { // Aplicar sobre la tarifa de vehículo
                amountDiscount = (aptReservations.vehicles.totalAmount * aptReservations.couponAmount) / 100;
            }
            aptReservations.total = totalWithCoupon - amountDiscount;
        } else if (aptReservations.couponType === 1) { // Descuento fijo
            aptReservations.total = totalWithCoupon - aptReservations.couponAmount;
        }
    
        // Actualizar la visualización del total en la interfaz de usuario
        $('#total-display').text(`$${aptReservations.total.toFixed(2)} USD`);
    }

    function formatErrors(errors) {
        if (Array.isArray(errors)) {
            return errors.join(', ');
        } else if (typeof errors === 'string') {
            return errors;
        } else if (typeof errors === 'object') {
            let allErrors = [];
            for (let key in errors) {
                if (errors.hasOwnProperty(key)) {
                    allErrors = allErrors.concat(errors[key]);
                }
            }
            return allErrors.join(', ');
        } else {
            return 'An unknown error occurred.';
        }
    }

    // Asignar valores al objeto aptReservations cuando se selecciona una aerolínea
    $('#arrival-airline').on('change', function() {
        aptReservations.arrivalAirline = $(this).val();
    });

    $('#departure-airline').on('change', function() {
        aptReservations.departureAirline = $(this).val();
    });

    // Asignar valores a flight numbers
    $('#arrival-flight-number').on('input', function() {
        aptReservations.arrivalFlightNumber = $(this).val();
    });

    $('#departure-flight-number').on('input', function() {
        aptReservations.departureFlightNumber = $(this).val();
    });

    // Event listeners para isOriginAirport y isDestinationAirport
    $('#isOriginAirport').on('change', function() {
        aptReservations.isOriginAirport = this.checked ? 1 : 0;
    });

    $('#isDestinationAirport').on('change', function() {
        aptReservations.isDestinationAirport = this.checked ? 1 : 0;
    });


    function cleanAptReservations() {
        // Crear un nuevo objeto limpio excluyendo destinationItem y valores undefined
        const cleanedReservations = Object.entries(aptReservations)
            .reduce((acc, [key, value]) => {
                if (value !== undefined && key !== 'destinationItem') {
                    acc[key] = value;
                }
                return acc;
            }, {});
        
        return cleanedReservations;
    }
    
    async function handleClientFormSubmit(e) {
        e.preventDefault();
        console.log('Formulario de cliente enviado');

        
        let errors = [];
        
        // Recopilar detalles del cliente dentro del objeto 'client'
        const clientData = {
            client_fname: $('#client-fname').val().trim(),
            client_lname: $('#client-lname').val().trim(),
            client_email: $('#client-email').val().trim(),
            client_phone: $('#client-phone').val().trim(),
            company_id: aptReservations.company_id  // Asegúrate de que company_id esté definido en aptReservations
        };

        // Aplicar la condición para aptRes_type
        if (aptReservations.isOriginAirport || aptReservations.isDestinationAirport) {
            aptReservations.aptRes_type = 1;
        } else {
            aptReservations.aptRes_type = 2;
        }

        // Asigna los datos del cliente en el objeto aptReservations bajo la clave `client`
        aptReservations.client = clientData;
    
        // Validar detalles de vuelo si es necesario
        if (aptReservations.isOriginAirport || aptReservations.isDestinationAirport) {
            if (aptReservations.isOriginAirport || aptReservations.serviceType === 2) {
                const arrivalAirline = $('#arrival-airline').val().trim();
                const arrivalFlightNumber = $('#arrival-flight-number').val().trim();
                aptReservations.arrivalAirline = arrivalAirline;
                aptReservations.arrivalFlightNumber = arrivalFlightNumber;
    
                if (!arrivalAirline) errors.push('La aerolínea de llegada es obligatoria.');
                if (!arrivalFlightNumber) errors.push('El número de vuelo de llegada es obligatorio.');
            }
    
            if (aptReservations.isDestinationAirport || aptReservations.serviceType === 2) {
                const departureAirline = $('#departure-airline').val().trim();
                const departureFlightNumber = $('#departure-flight-number').val().trim();
                aptReservations.departureAirline = departureAirline;
                aptReservations.departureFlightNumber = departureFlightNumber;
    
                if (!departureAirline) errors.push('La aerolínea de salida es obligatoria.');
                if (!departureFlightNumber) errors.push('El número de vuelo de salida es obligatorio.');
            }
        }
    
        // Validar "Departure Pickup Time" si aplica
        if (aptReservations.isDestinationAirport || aptReservations.serviceType === 2) {
            aptReservations.DepartureTime = $('#departure-pickup-time').val().trim();
            if (!aptReservations.DepartureTime) {
                errors.push('La hora de recogida de salida es obligatoria.');
            }
        }
    
        // Validar "Arrival Flight Time" si aplica
        if (aptReservations.isOriginAirport || aptReservations.serviceType === 2) {
            aptReservations.arrivalFlightTime = aptReservations.arrivalFlightTime;
            if (!aptReservations.arrivalFlightTime) {
                errors.push('La hora del vuelo de llegada es obligatoria.');
            }
        }
    
        // Mostrar errores si existen
        if (errors.length > 0) {
            displayClientErrors(errors);
            return;
        }
    
        // Ocultar errores previos y mostrar un spinner o indicador de carga si es necesario
        $('#client-errors').hide();
        $('#client-submit-button').prop('disabled', true).text('Procesando...');
    
        try {
            // Guardar los datos del cliente dentro de 'client'
            aptReservations.client = clientData;
            aptReservations.company_id = aptReservations.company_id; // Asegúrate de que esté definido
            aptReservations.special_requests = $('#special-requests').val().trim();
    
            // 1. Guardar los datos del cliente
            const clientResponse = await createClient(aptReservations.client);
            console.log('Respuesta del Cliente:', clientResponse);
            
            // Verificar dónde está el client_id en la respuesta
            let client_id = null;
            if (clientResponse.clientData && clientResponse.clientData.client_id) {
                client_id = clientResponse.clientData.client_id;
            } else if (clientResponse.client_id) {
                client_id = clientResponse.client_id;
            } else {
                throw new Error('ID de cliente no encontrado en la respuesta.');
            }
    
            if (client_id) {
                aptReservations.client_id = client_id; // Asigna directamente client_id en aptReservations
                console.log("Client ID asignado en aptReservations:", aptReservations.client_id);
            } else {
                throw new Error('El ID de cliente no fue encontrado en la respuesta.');
            }
    
            // Asignar los campos de vuelo a aptReservations
            if (clientData.arrivalAirline) {
                aptReservations.arrivalAirline = clientData.arrivalAirline;
            }
            if (clientData.arrivalFlightNumber) {
                aptReservations.arrivalFlightNumber = clientData.arrivalFlightNumber;
            }
            if (clientData.arrivalFlightTime) {
                aptReservations.arrivalFlightTime = clientData.arrivalFlightTime;
            }
            if (clientData.departureAirline) {
                aptReservations.departureAirline = clientData.departureAirline;
            }
            if (clientData.departureFlightNumber) {
                aptReservations.departureFlightNumber = clientData.departureFlightNumber;
            }
            if (aptReservations.DepartureTime) {
                aptReservations.DepartureTime = aptReservations.DepartureTime;
            }
    
            // 2. Iniciar el pago con Stripe
            const paymentData = {
                amount: aptReservations.total,
                currency: 'USD',
                client_name: `${aptReservations.client.fname} ${aptReservations.client.lname}`,
                client_email: aptReservations.client.email,
                client_phone: aptReservations.client.phone,
            };
            const paymentResponse = await initiateStripePayment(paymentData, aptReservations.company_id);
            const clientSecret = paymentResponse.client_secret;
    
            // 3. Confirmar el pago con Stripe
            const paymentSuccess = await handlePayment(clientSecret);
            if (!paymentSuccess) {
                throw new Error('El procesamiento del pago ha fallado.');
            }
    
            // 4. Guardar la reserva
            const reservationResponse = await createAptReservation(aptReservations, 1);
            aptReservations.booking_id = reservationResponse.booking_id;
    
            // 5. Actualizar la interfaz de usuario a la pestaña de confirmación
            activateTab('confirm');
    
            // Opcional: Mostrar detalles de la reserva
            displayAptReservations();
    
        } catch (error) {
            console.error('Error durante el envío del formulario de cliente:', error);
            displayClientErrors([error.message]);
        } finally {
            // Rehabilitar el botón de envío y restaurar el texto original
            $('#client-submit-button').prop('disabled', false).text('Purchase completed');
        }
    }
    
    $('#client-form').on('submit', handleClientFormSubmit);

    // Función para guardar los datos del cliente
    async function createClient(clientData) {
        
        console.log('Esto mando al Cliente:', clientData);
        try {
            const response = await fetch(`${apiURL}public/clients`, {
                method: 'POST',
                headers: {
                    'Accept': 'application/json',
                    'Content-Type': 'application/json',
                },
                body: JSON.stringify(clientData)
            });
    
            const data = await response.json();
            console.log('Client Response:', data);
    
            if (!data.errors) {
                return data; // Asumiendo que la respuesta contiene client_id
            } else {
                throw new Error(formatErrors(data.errors));
            }
        } catch (error) {
            console.error('Error creating client:', error);
            throw error;
        }
    }    

    async function initiateStripePayment(paymentData, companyID) {
        try {
            const response = await fetch(`${apiURL}payment/initiate`, {
                method: 'POST',
                headers: {
                    'Accept': 'application/json',
                    'Content-Type': 'application/json',
                    'User-Company': companyID
                },
                body: JSON.stringify(paymentData)
            });
    
            const data = await response.json();
            console.log('Payment Initiate Response:', data);
    
            if (!data.errors) {
                return data; // Asumiendo que la respuesta contiene client_secret
            } else {
                throw new Error(formatErrors(data.errors));
            }
        } catch (error) {
            console.error('Error initiating Stripe payment:', error);
            throw error;
        }
    }    
    
    // Función para manejar el pago con Stripe
    async function handlePayment(clientSecret) {
        try {
            const { error, paymentIntent } = await stripe.confirmCardPayment(clientSecret, {
                payment_method: {
                    card: cardNumberElement,
                    billing_details: {
                        name: `${aptReservations.client.fname} ${aptReservations.client.lname}`,
                        email: aptReservations.client.email,
                        phone: aptReservations.client.phone
                    }
                }
            });
    
            if (error) {
                console.error('Payment confirmation error:', error.message);
                throw new Error(error.message);
            }
    
            if (paymentIntent && paymentIntent.status === 'succeeded') {
                console.log('Payment succeeded:', paymentIntent.id);
                aptReservations.paymentIntent = paymentIntent.id; // Almacenar el ID del PaymentIntent
                return true;
            } else {
                console.error('Payment failed:', paymentIntent);
                throw new Error('Payment failed. Please try again later.');
            }
        } catch (error) {
            console.error('Error during payment processing:', error);
            throw error;
        }
    }

    // Función para guardar la reserva
    async function createAptReservation(aptReservationsData, status) {
        try {
            const payload = {
                bookingObject: JSON.stringify(aptReservationsData) // Enviar como objeto, no como cadena
            };

            const response = await fetch(`${apiURL}public/apt-reservations`, {
                method: 'POST',
                headers: {
                    'Accept': 'application/json',
                    'Content-Type': 'application/json',
                    'Reservation-Status': status
                },
                body: JSON.stringify(payload)
            });

            const data = await response.json();
            console.log('Reservation Response:', data);

            if (data.message === 'Apt Reservation created successfully') {
                return data.data; // Asumiendo que la respuesta contiene booking_id
            } else {
                throw new Error(formatErrors(data.errors || data.error));
            }
        } catch (error) {
            console.error('Error creating reservation:', error);
            throw error;
        }
    }

    function displayClientErrors(errors) {
        const errorsContainer = $('#client-errors');
        errorsContainer.html('<ul class="left-align-list" style="text-align: start !important;"></ul>');
        if (typeof errors === 'string') {
            errorsContainer.find('ul').append(`<li>${errors}</li>`);
        } else if (Array.isArray(errors)) {
            errors.forEach(error => {
                errorsContainer.find('ul').append(`<li>${error}</li>`);
            });
        }
        errorsContainer.show();
    }

    function displayAptReservations() {
        // Serializar el objeto aptReservations en una cadena JSON con formato
        const aptReservationsJson = JSON.stringify(aptReservations, null, 2);
        
        // Insertar la cadena JSON en el elemento <pre>
        $('#apt-reservations-display').text(aptReservationsJson);
        
        // Log para verificar
        console.log('aptReservations:', aptReservations);
    }

    /* ||||||||||||||||||||||||||||||||||| FUNCIONES CLIENTS ||||||||||||||||||||||||||||||||||||||| */

    // Inicializar los campos dinámicos al cargar
    updateDynamicFields();
});


